<template>
    <v-container>
      
      <v-dialog
          v-model="withdrawSuccess"
          elevation="24"
          class="text-center"
          width="20%"
        >
        <span class="text-h5">Transaktion erfolgreich!</span>
          <img src="../assets/success_animation.gif" alt="success-animation">  
        </v-dialog>
    
        <v-row justify="center">
        <v-dialog
          v-model="dialog"
          persistent
          max-width="600px"
        >
          <template v-slot:activator="{ on, attrs }">
            <v-container>
            <v-row class="justify-end mt-5">
            <v-btn 
              color="info"
              dark
              v-bind="attrs"
              v-on="on"
              rounded
              large
            >
              <v-icon>Transfer</v-icon>
            </v-btn>
        </v-row>
    </v-container>
          </template>
          <v-card>
            <v-card-title>
              <span class="text-h5">Geld transferieren</span>
            </v-card-title>
            <v-card-text>
              <v-form>
              <v-container>
                <v-row>
                  <!-- item-text liest den namen aus dem object. Aber keine Ahnung warum name in '' geschrieben werden muss-->
                  <v-col cols="12">
                    <span class="test-h5">Von</span>
                    <v-select
                    v-model="kontoId1"
                    :items="allKontoViewAll"
                    :item-text="'name'"
                    :item-value="'id'"
                    name="name"
                    label="Wähle dein Konto"
                    required
                    return-object
                    v-on:change="showSpaceSelection1 = true"
                  ></v-select>
                  </v-col>
                  <v-col cols="8"  v-show="this.showSpaceSelection1 == true">
                    <v-select
                      v-show="this.kontoId1 != null"
                      v-model="fromSpaceDetails"
                      label="Wähle deinen Space"
                      required
                      :items="kontoId1.spacesSet"
                      :item-text="'name'"
                      return-object
                    ></v-select>
                  </v-col>
                  <v-col cols="4">
                    <h3 v-show="this.showSpaceSelection1 == true">
                    €{{ fromSpaceDetails.accountBalance }} Guthaben</h3>
                  </v-col>

                  <v-col cols="12">
                    <!-- <v-btn @click="test()">LogTest</v-btn> -->
                    <v-divider color="" role="presentation" class="divider-top"></v-divider>
                  </v-col>
                  
                  <v-col cols="12">
                    <span class="test-h5">Nach</span>
                    <v-select
                    v-model="kontoId2"
                    :items="allKontoViewAll"
                    :item-text="'name'"
                    :item-value="'id'"
                    name="name"
                    label="Wähle dein Konto"
                    required
                    return-object
                    v-on:change="showSpaceSelection2 = true"
                  ></v-select>
                  </v-col>
                  <v-col cols="8"  v-show="this.showSpaceSelection2 == true">
                    <v-select
                      v-show="this.kontoId2 != null"
                      v-model="toSpaceDetails"
                      label="Wähle deinen Space"
                      required
                      :items="kontoId2.spacesSet"
                      :item-text="'name'"
                      return-object
                    ></v-select>
                  </v-col>
                  <v-col cols="4">
                    <h3 v-show="this.showSpaceSelection2 == true">
                    €{{ toSpaceDetails.accountBalance }} Guthaben</h3>
                  </v-col>

                  <v-col cols="12">
                    <!-- <v-btn @click="test()">LogTest</v-btn> -->
                    <v-divider color="" role="presentation" class="divider-top"></v-divider>
                  </v-col>

                  <v-col cols="12">
                    <span class="test-h5">Betrag</span>
                  <v-text-field
                    v-model="transferAmount"
                    label="€"
                    required
                    :rules="withdrawAmountRules"
                    :counter="30"
                  ></v-text-field>
                </v-col>
                </v-row>
              </v-container>
            </v-form>
              <!-- <small>*indicates required field</small> -->
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                color="blue darken-1"
                text
                @click="dialog = false"
              >
                Zurück
              </v-btn>
              <v-btn
                color="blue darken-1"
                text
                @click="transferFunds(), dialog = false"
              >
                OK
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-row>
    </v-container>
    </template>
      
      <script>
    
        export default {
          name: 'TransferFunds',
    
        props: {
              kontoIdProp: String,
          },
    
          data()  {
            return {
                dialog: false,
    
                kontoId1: [],
                kontoId2: [],

                showSpaceSelection1: false,
                showSpaceSelection2: false,

                transferAmount: "",
  
                fromSpaceDetails: {
                  id: "",
                  name: "",
                  description: "",
                  accountBalance: ""
                },

                toSpaceDetails: {
                  id: "",
                  name: "",
                  description: "",
                  accountBalance: ""
                },      
    
                withdrawSuccess: false,
    
                withdrawAmountRules: [
                  v => !!v || 'Wird benötigt',
                  v => v <= this.fromSpaceDetails.accountBalance || 'Zu wenig Guthaben!',
                  v => v > 0 || 'Der Betrag muss größer 0 sein',
                ]
            
          }},
    
          computed: {
            postKontoDialogState() {
                return this.$store.state.postKontoDialog
            },
  
            allSpacesList() {
                return this.$store.state.allSpacesByKontoId.spaces
            },

            allKontoOverview() {
                return this.$store.state.allKontoOverview;
            },

            allKontoViewAll() {
                return this.$store.state.allKontoViewAll;
            }
          },
    
          mounted() {
            this.getKontoViewAll()
          },
    
          methods: {
            getAllSpacesByKontoId(id) {
              console.log(id)
              this.$store.dispatch("getAllSpaceByKontoId", id);
            },

            getKontoAccountBalance() {
              this.$store.dispatch("getAccountBalance", this.kontoId1);
            },

            getKontoViewAll() {
              this.$store.dispatch("getAllKontoViewAll");
            },

            async transferFunds() {
              var transferDetails = {
                transferAmount: "",
                space1_id: "",
                space2_id: ""
              }

              transferDetails.transferAmount = this.transferAmount;
              transferDetails.space1_id = this.fromSpaceDetails.id;
              transferDetails.space2_id = this.toSpaceDetails.id;

              await this.$store.dispatch('transferFunds', transferDetails).then(() => {
                this.showWithdrawSuccess();
              })
            },
          
          showWithdrawSuccess() {
            setTimeout(() => {
              this.withdrawSuccess = true;
            }, 100)
            setTimeout(() => {
              this.withdrawSuccess = false;
              window.location.reload();
              }, 2500);
          },         
          }
          
        }
      </script>
      